/* +-----------------------------------------------------------------+
   | (C) SELIAtec S.A.                                               |
   +-----------------------------------------------------------------+
   | Tel :  88 86 68 54                                              |
   | Fax :  88 86 74 76                                              |
   +-------------------------------+---------------------------------+
   | Projet   : CF01               |     Compilateur : Visual C++    |
   | Nom      : cf01.h             |     Version     : 4.00 WIN32    |
   +-------------------------------+---------------------------------|
   | Auteur    : Frank Diebolt     |     Date       : 28 Mai 1997    |
   +-------------------------------+---------------------------------+
   | Descript. :                                                     |
   |   Ce fichier d'entte constitue la dfinition de l'interface    |
   |   pour accder aux fonctions des diffrents modules d'une CF01  |
   |   (Sous Win3.1, win95 et winNT)                                 |
   +-----------------------------------------------------------------+
   |                         MISES A JOUR	  												 |
   +----------+-----------+------------------------------------------+
   |   Date   |   Auteur  |          Description des mises  jour		 |
   +----------+-----------+------------------------------------------+
   |5/05/94   |F. SANJARI | Cration V 1.00                          |
   +----------+-----------+------------------------------------------+
   |24/07/95  |JM. HILAIRE| Mise  jour                              |
   +----------+-----------+------------------------------------------+
   |24/06/96  |F. GLOHR   | Mise  jour                              |
   +----------|-----------+------------------------------------------+ 
   |11/04/97  |F. GLOHR   | Modification pour la nouvelle MA03N      |
   +----------|-----------+------------------------------------------+ 
   |20/05/97  |F. DIEBOLT | Modification pour windows 32 (win 95/NT) |
   +----------|-----------+------------------------------------------+ 
   |02/03/00  |V. PATTEIN | Modification MC01 Maitre/Esclave         |
   +----------|-----------+------------------------------------------+ 


																			*/

#include <windows.h>

#ifdef WIN32

#ifdef EXPORT
#define _CDECL_ __declspec(dllexport) WINAPI
#else
#define _CDECL_	__declspec(dllimport) WINAPI
#endif
#else
#define _CDECL_		FAR PASCAL 
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef WIN32
	int  _CDECL_ WINAPI WEP(int);
#endif

	unsigned long _CDECL_	 CF01_Inportb(int portid);
	void					_CDECL_  CF01_Outportb(int portid,unsigned long value);

	int           _CDECL_  MD01_ReadInput(int AdrModule);

	void          _CDECL_  MD02_WriteOutput(int AdrModule,int Value);

	void          _CDECL_  MD03_WriteOutput(int AdrModule,int Value);
	int           _CDECL_  MD03_ReadInput(int AdrModule);

	void          _CDECL_  MD04_WriteOutput(int AdrModule,int Value);

	void          _CDECL_  MD05_WriteOutput(int AdrModule,int Value);

	void          _CDECL_  MD06_WriteOutput(int AdrModule,unsigned int Value);

	void          _CDECL_  MD07_WriteOutput(int AdrModule,unsigned int Value);

	int           _CDECL_  MA01_ReadAnalogueIn(int AdrModule,int Channel,unsigned long TimeOut);

	void          _CDECL_  MA02_WriteAnalogueOut(int AdrModule,int Channel,int Value);

	void          _CDECL_  MA04_WriteAnalogueOut(int AdrModule,int Channel,int Value);

	int           _CDECL_  MA03_ReadAnalogueIn(int AdrModule,int Channel,unsigned long TimeOut);

	void          _CDECL_  MC02_ClearCounter (int AdrModule);
	unsigned long _CDECL_  MC02_ReadCounter (int AdrModule);
	void          _CDECL_  MC02_PresetCounter (int AdrModule, unsigned long Preset);
	unsigned long _CDECL_  MC02_ReadLatchCounter (int AdrModule);
	int           _CDECL_  MC02_IsLineExtern (int AdrModule);
	int           _CDECL_  MC02_IsLineFault (int AdrModule);

	void          _CDECL_  MC04_ClearCounter (int AdrModule);
	unsigned long _CDECL_  MC04_ReadCounter (int AdrModule);
	void          _CDECL_  MC04_PresetCounter (int AdrModule,unsigned long Preset);
	unsigned long _CDECL_  MC04_ReadLatchCounter (int AdrModule);
	int           _CDECL_  MC04_IsLineExtern (int AdrModule);
	int           _CDECL_  MC04_IsLineFault (int AdrModule);

	void          _CDECL_  MC03_ClearCounter (int AdrModule);
	unsigned long _CDECL_  MC03_ReadCounter (int AdrModule);
	void          _CDECL_  MC03_PresetCounter (int AdrModule, unsigned long Preset);
	unsigned long _CDECL_  MC03_ReadLatchCounter (int AdrModule);

	void          _CDECL_  MC05_ClearCounter (int AdrModule);
	unsigned long _CDECL_  MC05_ReadCounter (int AdrModule);
	void          _CDECL_  MC05_PresetCounter (int AdrModule,unsigned long Preset);
	unsigned long _CDECL_  MC05_ReadLatchCounter (int AdrModule);

	unsigned long _CDECL_  MC01_ReadCounter (int AdrModule);
	void          _CDECL_  MC01_Mode (int AdrModule,int Value);
	void          _CDECL_  MC01me_ExtMode(int AdrModule, int frequency, int length, int code, int master, int start);

#ifdef WINNT
	int						_CDECL_ CF01_GetModuleName	(char *buffer,int card_no,int slot);
	int						_CDECL_ CF01_GetModuleStart	(int card_no);
	int						_CDECL_ CF01_GetModuleEnd		(int card_no);
	int						_CDECL_ CF01_IsModuleOk			(int portid);
#endif

#ifdef __cplusplus
};
#endif
