{  Ŀ
    (C) SELIA design                                                      
   Ĵ
    Tel :  (00 33) 88 86 68 54                                            
    Fax :  (00 33) 88 86 74 76                                            
   Ĵ
    Project     : CF01                 Compiler   : TURBO PASCAL         
    Module name : MA01.PAS             Version    : 6.00                 
   Ĵ
    Author    : Francis GLOHR          Date       : 17 March 1994        
   Ĵ
    Descript. :                                                           
                 Function to use the CF01 with MA01 modules               
   Ĵ
                                UPDATES                                   
   Ĵ
      Date      Author            Description of updates                
   Ĵ
   17/03/94  F. Glohr    Creation V 1.00                                
   --------- -----------------------------------------------------------
   }
program MA01;

uses Dos, Crt;

{  Ŀ
    Const definition                                                      
   }

{ Base adress of the CF01 board is Hex 300 = Dec 768
  ****************************************************}

CONST
      AdrModule = $300;                         { Module is at position "A"     }
                                                { onto the CF01                 }


{ -------------------------------------------------------------------------
  Note: For over module position you must correct the constant ADRMODULE
        with the correct module adresse as specified in the CF01 handbook
  -------------------------------------------------------------------------}





{  Ŀ
    Name :  MA01ReadInputBit                                              
   Ĵ
    Description :                                                         
      Read analogue input value                                           
   Ĵ
    Input :  AdrModule : INTEGER: Adress of the MA01 module (see Note)    
             Bit       : INTEGER: Channel number (1..8)                   
   Ĵ
    Output:  INTEGER : result from the reading of MA01                    
   }
Function MA01AnalogIn (AdrModule : INTEGER; Channel : INTEGER):INTEGER;
Begin
   Port[AdrModule] := Channel - 1;      { Channel select }
   Delay (1);
   Port[AdrModule + 1] := 0;            { Start conversion }

   Repeat
   until (Port[AdrModule + 1] AND 1) <> 1;

   MA01AnalogIn := (Port[AdrModule] shl 4) + (Port[AdrModule+1] shr 4);
End;

{  Ŀ
    Name :  MA01Bin2Real                                                  
   Ĵ
    Description :                                                         
      Convert Bunary to Real value                                        
   Ĵ
    Input :  AdrModule : INTEGER: Adress of the MA01 module (see Note)    
   Ĵ
    Output:  INTEGER : Converting value                                   
   }
Function MA01Bin2Real (BinValue:INTEGER; Mini:Real; Maxi:Real):REAL;
Var
   alsb : Real;
Begin
   alsb := Abs(Mini - Maxi) / 4096.0;
   MA01Bin2Real := (BinValue * alsb) + Mini;
End;

{  Ŀ
    Name :  main                                                          
   Ĵ
    Description :                                                         
      Example to use the MA01 module                                      
   Ĵ
    Input :                                                               
   Ĵ
    Output:                                                               
   }
Var
   k   : Integer;
   Bin : Integer;
   Volt: Real;

Begin

   ClrScr;
   GoToXY (10, 1); Write ('Example for use the MA01 module with the CF01 board');
   GoToXY (10, 2); Write ('-----------------------------------------------------');

   GoToXY (10, 4); Write ('Press a key to quit program');

   GoToXY (5, 6); Write ('Ŀ');
   GoToXY (5, 7); Write (' Channel  Bin value  Voltage     %   ');
   GoToXY (5, 8); Write ('Ĵ');

   For k:= 0 To 8 Do Begin
      GoToXY (5, 9+k); Write ('  ',k:2,'                                 ');
   End;
   GoToXY (5, 17);    Write ('');

   Repeat
      For k := 1 To 8 Do Begin
         Bin := MA01AnalogIn (AdrModule, k);
         GoToXY (19, 8+k);Write (Bin:4);
         Volt := MA01Bin2Real (Bin, 0.0, 10.0);
         GoToXY (30, 8+k);Write (Volt:3:4);
         Volt := MA01Bin2Real (Bin, 0.0, 100.0);
         GoToXY (40, 8+k);Write (Volt:3:0);
      End;
   Until KeyPressed;
End.
